#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct
{
    char pismeno;
    int pocet;
}DATA;

FILE * otevreni_souboru(char rezim[2], char vystup[34])
{
    FILE *f;
    if((f=fopen(vystup,rezim))==NULL)
    {
        printf("Soubor %s nelze otevrit",vystup);
        exit(-1);
    }
    return(f);
}
void zavreni_souboru(FILE *f)
{
   if((fclose(f))==EOF)
    {
        printf("Soubor nelze uzavrit");
        exit(-1);
    }
}
void soubor(char text[1000], char vystup[34])
{
    FILE *fw;
    DATA *pa;
    int znaku ='z'-'a'+1;
    int i;

    pa=(DATA *)malloc(znaku*sizeof(DATA));
    for(i=0; i<znaku; i++)
    {
        pa[i].pocet=0;
        pa[i].pismeno='a'+i;
    }
    for(i=0; i<strlen(text); i++)
    {
        if(text[i]>='a'&&text[i]<='z')
            pa[text[i]-'a'].pocet++;
    }
    fw=otevreni_souboru("w", vystup);
    for(i=0; i<znaku; i++)
    {
        printf("%c\t%d\n",pa[i].pismeno,pa[i].pocet);
        fprintf(fw,"%c\t%d\n",pa[i].pismeno,pa[i].pocet);
    }
    zavreni_souboru(fw);
    free((void *)pa);
    pa=NULL;
}
void kopie_souboru(char vystup[34])
{
    FILE *fw, *fr;
    char c;
    fr=otevreni_souboru("r", vystup);
    fw=otevreni_souboru("w", "kopie.txt");
    while((c=getc(fr))!=EOF)
    {
        putchar(c);
        putc(c,fw);
    }
    zavreni_souboru(fw);
    zavreni_souboru(fr);
}
int main()
{
    char text[1000];
    char nazev[30], vystup[34];
    printf("Zadej text\n");
    gets(text);  /* nelze omezit delku zadaneho textu */
    printf("\nZadej nazev souboru bez pripony:\n");
    scanf("%29s",nazev);
    sprintf(vystup,"%s.txt",nazev);
    soubor(text, vystup);
    printf("\nBude vytvorena kopie souboru %s:\n", vystup);
    kopie_souboru(vystup);
    return 0;
}
